package cn.net.cpzslibs.prot.handset.jinLiquor;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.jinLiquor.Jin20006ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.jinLiquor.Jin20006ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Jin20006Group extends ProtBase {
	
	private final short iTaskCode20006 = 20006;
	private Gson gson;
	private Jin20006ResBean resBean;
//	{"list":[{"cid":"1","id":1,"name":"一班"},{"cid":"1","id":2,"name":"二班"},{"cid":"1","id":3,"name":"三班"},{"cid":"1","id":4,"name":"四班"}]}
	public Jin20006Group() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Jin20006ResBean getResBean(){
		return this.resBean;
	}
	
	public void reqGroup(SocketCreate create, Jin20006ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(),reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
                         DataInputStream dis, Jin20006ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20006, "开始请求信息");
				sendProt(dos,reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20006, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20006, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Jin20006ResBean.class);
		}
//		
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Jin20006ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20006, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
